#include "../minion.h"
/* Minion Constraint Solver
   http://minion.sourceforge.net
   
   For Licence Information see file LICENSE.txt 
*/

#include "../constraints/constraint_difference.h"

template<typename VarRef1, typename VarRef2>
AbstractConstraint*
BuildCT_DIFFERENCE(StateObj* stateObj,const vector<VarRef1>& vars, const vector<VarRef2>& var2, ConstraintBlob&)
{ 
  D_ASSERT(vars.size() == 2);
  D_ASSERT(var2.size() == 1);
  return new DifferenceConstraint<VarRef1,VarRef1,VarRef2>(stateObj, vars[0], vars[1], var2[0]); 
}

BUILD_CT(CT_DIFFERENCE, 2)
