#include "../minion.h"
/* Minion Constraint Solver
   http://minion.sourceforge.net
   
   For Licence Information see file LICENSE.txt 
*/

#include "../constraints/reify.h"
#include "../constraints/constraint_equal.h"

template<typename VarRef1, typename VarRef2, typename BoolVarRef>
AbstractConstraint*
BuildCT_DISEQ_REIFY(StateObj* stateObj, const vector<VarRef1>& var1, 
                                        const vector<VarRef2>& var2, const vector<BoolVarRef> var3, ConstraintBlob&)
{ return new ReifiedEqualConstraint<VarRef1, VarRef2, VarNot<BoolVarRef> >
                                   (stateObj,var1[0],var2[0], VarNotRef(var3[0])); }

BUILD_CT(CT_DISEQ_REIFY, 3)
