#include "../minion.h"
/* Minion Constraint Solver
   http://minion.sourceforge.net
   
   For Licence Information see file LICENSE.txt 
*/

#include "../constraints/reify_true.h"
#include "../constraints/reify_true_old.h"

template<typename VarArray>
inline AbstractConstraint*
BuildCT_REIFYIMPLY_NEW(StateObj* stateObj, const VarArray& vars, ConstraintBlob& bl)
{
  D_ASSERT(bl.internal_constraints.size() == 1);
  D_ASSERT(vars.size() == 1);
  return truereifyCon(stateObj, build_constraint(stateObj, bl.internal_constraints[0]), vars[0]);
}

template<typename VarArray>
inline AbstractConstraint*
BuildCT_REIFYIMPLY_OLD(StateObj* stateObj, const VarArray& vars, ConstraintBlob& bl)
{
  D_ASSERT(bl.internal_constraints.size() == 1);
  D_ASSERT(vars.size() == 1);
  return truereifyConOld(stateObj, build_constraint(stateObj, bl.internal_constraints[0]), vars[0]);
}

template<typename VarArray>
inline AbstractConstraint*
BuildCT_REIFYIMPLY(StateObj* stateObj, const VarArray& vars, ConstraintBlob& bl)
{
#ifdef OLD_REIFYIMPLY
#warning Using old Reifyimply
  return BuildCT_REIFYIMPLY_OLD(stateObj, vars, bl);
#else
  return BuildCT_REIFYIMPLY_NEW(stateObj, vars, bl);
#endif
}

BUILD_CT(CT_REIFYIMPLY, 1)
